from uci import UciExceptionNotFound
from EEUci import EEUci as Uci
import simplejson as json                                                                             
import sys                                                                                            


def gen_pmFunction(name):

      return {
        "name": name,
        "lowercase_name": name.lower(),
        "display_name": name,
        "description": name,
      }

def gen_subAssemblyInstance(name):
      return {
        "name": name,
        "lowercase_name": name.lower(),
        "display_name": "",
      }

def gen_user_required_input(name,type="decimal"):

      return {
        "name": name,
        "lowercase_name": name.lower(),
        "display_name": name,
        "valueType": type,
        "valueStart": 0,
        "valueStop": 0,
        "default": ""
      }


def gen_user_input(rule):
    print("rule is: ",rule)
    u = {
        "machineId": rule["machine_id"],
        "value": rule['value'],
        "pmFunction": gen_pmFunction(rule['pm_function']),
        "subAssemblyInstance": gen_subAssemblyInstance(rule['subassembly']),
        "userRequiredInput": gen_user_required_input(rule['name'])
    }
    return u



def genUciRules():                    
    u = Uci()
    print("Getting rules..")
    try:
        rules = u.get("gaugerules",stype ="rule")
        #print("Rules: ",json.dumps(rules,indent=4))                                      
    except UciExceptionNotFound as e:                    
        return []                                      

    ui_list={}

    for cfg,rule in rules.items():
        ui = gen_user_input(rule)
        #print("ui: ",json.dumps(ui,indent=3))
        if ui:
            if not rule["machine_id"] in ui_list:
              ui_list[rule["machine_id"]]=[]
            ui_list[rule["machine_id"]].append(ui)

    return ui_list

# if not machines:                                       
#     return None                                      
# for cfg,m in machines.items():                        
#   m["sensors"] = get_sensors(u,m['id'])             
                                                    
# print("Machines: ",json.dumps(machines,indent=4))            

# all_rules=genUciRules()

# for gauge_file in all_rules:
#   gauge_details = {"gaugeUserInputs": all_rules[gauge_file]}

#   print("gauge_details: \n", json.dumps(gauge_details,indent=3))

