from uci import UciExceptionNotFound
from EEUci import EEUci as Uci
import simplejson as json

def gen_baselines(baselines):
    baseline_dict={}
    for cfg,baseline in baselines.items():
        if not baseline["machine_id"] in baseline_dict:
            baseline_dict[baseline["machine_id"]]=[]
            baseline_dict[baseline["machine_id"]].append(baseline)
        else:
            baseline_dict[baseline["machine_id"]].append(baseline)
    print("Baselines: ",json.dumps(baseline_dict,indent=4))
    return baseline_dict

def genUciBaselines():                    
    u = Uci()
    print("Getting Baselines..")
    try:
        baselines = u.get("baselines",stype ="baseline")                                    
    except UciExceptionNotFound as e:                    
        return []                                      
    return gen_baselines(baselines)