from uci import UciExceptionNotFound
from EEUci import EEUci as Uci
import simplejson as json
import sys
import getopt

#file="/tmp/gauge_rules.json"
default_uci_config_file ="gaugerules_config"
#n="rule"



#        option machine_id 'id'
#        option subassembly 'motorSense1'
#        option 'name' 'yellow_threshold'
#        option value '1'
 #       option pm_function 'Current Imbalance'


def get_gauge_rules_json(fname):
    with open(fname,"r") as f:
        data = json.load(f)
    #print(data)
    return data



def gen_gauge_rule(machine_id,subassembly_name,data):
    global u
    global uci_config_file

    if 'rules' not in data:
        return
    for rule in data['rules']:
        u = Uci()
        #print("Generting for: ",rule['name'])
        rule_key = u.add(uci_config_file,"rule")
        #print(f"ADD RULE: {rule_key}",rule)
        u.set(uci_config_file,rule_key,'machine_id', machine_id)
        u.set(uci_config_file,rule_key,'subassembly', subassembly_name)
        u.set(uci_config_file,rule_key,'name', rule['name'])
        u.set(uci_config_file,rule_key,'pm_function', data['display_name'])
        u.commit(uci_config_file)
        u=None


def clear_uci_config(cfile):
    f = open("/etc/config/" + cfile,"a")
    f.truncate(0) 
    f.close()


def gen_machine_rule(machine,data):
    for subassembly_name,subassembly in data.items():
        #key=machine+"_"+subassembly_name
        #print(f"SUB({key}): ",subassembly)
        for gauge_name,gauge in subassembly.items():
            #key2=key+"_"+gauge_name
            #print(f"{key2}: ",gauge)
            gen_gauge_rule(machine,subassembly_name,gauge)
    #u.commit(c)


def usage(prog_name):
    print(f"usage: {prog_name} rules_file.json")
    sys.exit(1)

#u = Uci()

#u.set(c,"xx","rule")

#u.set(c,"xx",'machine_id', 'id')

    try:                                                                             
        opts, args = getopt.getopt(sys.argv[1:],"c:R:")                              
    except getopt.GetoptError:
        usage(sys.argv[0])



args = sys.argv[1:]

if len(args) != 1:
    print("Must give json file.")
    usage(sys.argv[0])

uci_config_file = default_uci_config_file
file=args[0]

clear_uci_config(uci_config_file)
d = get_gauge_rules_json(file)


for m,data in d.items():
   gen_machine_rule(m,data)


#u.commit(c)

